#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>
#include <stdlib.h>
#include "Messagetypes.h"

#define PI 3.14159

typedef enum message_to_robot_type Mensaje_A_Robot;
int estado=0,estado_anterior=-1;
int mina=0, tarta=0, ultimo=10;
double distancia_v, distancia_n;
double angulo_v, angulo_n;

void Chequea_Mensaje(int sig);
void Gira_Angulo(int que, double velocidad, double angulo);

Mensaje_A_Robot Devuelve_Mensaje(char* mensaje);

int direccion(){/*a la izquierda devuelve 1, a la derecha -1*/
	if(angulo_n>angulo_v){
		return 1;
	}else{
		return -1;
	}
}

int main(void)
{  
   int salir=0, que=7; 
   double velocidad=0.75, angulo=6.32;
   signal(SIGUSR1, Chequea_Mensaje);
   printf("RobotOption 2 %d\n",SIGUSR1);
   fflush(stdout);
   while(!salir)
   {/*1:Robot, 2:Caon, 4:Radar
   	printf("Print Estado=%d; Estado Anterior=%d; Tarta=%d; Mina=%d\n",estado,estado_anterior,tarta,mina);
	printf("Print estado=%d\n",estado);*/
	if(estado==0){/*estado inicial*/
		printf("Rotate 7 0.8\n");
		printf("Accelerate 1.3\n");
	}else if(estado==1){/*veo una pared cerca, o una mina cerca*/
			printf("RotateTo 6 1 0\n");
			printf("Brake 1\n");
			printf("RotateAmount 1 2 %f\n",direccion()*PI/5);
	}else if(estado==2){/*Normal*/
		printf("Brake 0.1\n");
		printf("Accelerate 1.3\n");
		printf("Sweep 4 2 %f %f\n",-PI/4,PI/4);
	}else if(estado==3){/*veo un robot*/
		printf("Brake 0.3\n");
		printf("RotateTo 6 3 0\n");
		printf("RotateAmount 1 3 %f\n",angulo_n);
		printf("Sweep 4 2 %f %f\n",-PI/4,PI/4);
	}else if(estado==4){/*ataco al robot*/
		if(distancia_n>4){
			printf("Brake 0.5\n");
		}else{
			printf("Brake 1\n");
		}
		printf("Sweep 4 3 %f %f\n",-PI/4,PI/4);
		printf("RotateTo 2 3 0\n");
		printf("RotateAmount 1 3 %f\n",angulo_n);
		if(distancia_n>4){
			printf("Shoot 15\n");
		}else{
			printf("Shoot 30\n");
		}
	}else if(estado==5){/*veo una tarta*/
		printf("Sweep 4 2 %f %f\n",-PI/12,PI/12);
		if(tarta){
			if(distancia_n>5){
				printf("Brake 0.4\n");
			}else{
				printf("Brake 1\n");
			}
							
			if(angulo_n!=angulo_v){
				printf("RotateAmount 1 1 %f\n",angulo_n);
				printf("RotateTo 6 3 0\n");
				tarta=0;
			}
		}	
	}else if(estado==6){/*reventar mina*/
		printf("Sweep 4 2 %f %f\n",-PI/12,PI/12);
		if(mina){
			printf("Brake 1\n");
			if(angulo_n!=angulo_v){
				printf("RotateAmount 1 1 %f\n",angulo_n);
				printf("RotateTo 6 3 0\n");
				printf("Shoot 1\n");
				mina=0;
			}	
		}
	}
				
	fflush(stdout);

	sleep(1);

   }
}

void Chequea_Mensaje(int sig)
{
   static int cuenta=0;
   double distancia, angulo;
   int tipo;
   char mensaje[81];
   while (scanf("%s",mensaje) != EOF)
   {
      Mensaje_A_Robot Recibido;
      Recibido=Devuelve_Mensaje(mensaje);
      estado_anterior=estado;
      switch (Recibido)
      {
         float aceleracion;
         unsigned char numero;
         case INITIALIZE:
              {  int numero;
                 scanf("%d",&numero);
                 if (numero==1)
                { printf("Name djyuis\n");
                  printf("Colour 22ff22 00dd33\n");
                  fflush(stdout);
                 }
              }
              break;
         case GAME_STARTS:
	 {
            
            /*printf("Rotate 7 1 0.3");*/
	    fflush(stdout);
	    }
            break;
	 case ROTATION_REACHED:
	       {

	       }
	   break;
	 /*case ENERGY:
	       {
	       int vida;
	       scanf("%d",&vida);
	       		       
	       }	
	   break;*/
	 case RADAR:
	    {
	    	char sdistancia[20];
		char sangulo[20];
	    	scanf("%s",&sdistancia);
		scanf("%d",&tipo);
		scanf("%s",&sangulo);
		fflush(stdin);
		distancia=atof(sdistancia);
		angulo=atof(sangulo);

		angulo_v=angulo_n;
		angulo_n=angulo;
		distancia_v=distancia_n;
		distancia_n=distancia;

		
		if(tipo==LAST_OBJECT_TYPE){/*es del ultimo tipo recibido*/
			tipo=ultimo;
			printf("Print Ultimo\n");
			fflush(stdout);
		}
		ultimo=tipo;
		if(tipo==ROBOT){
			if(estado==0){
				estado=3;
			}else if(estado==1){
				estado=3;
			}else if(estado==2){
				estado=3;
			}else if(estado==3){
				estado=4;
			}else if(estado==5){
				estado=3;
			}else if(estado==6){
				estado=3;
				mina=0;
			}

		}else{
			if(estado==4){
				cuenta++;
				if(cuenta>=10){
					estado=3;
				}
			}else if(estado==3){
				estado=2;
			}
			

			if(tipo==WALL){
				if(estado==0 && distancia_n < 6){
					estado=1;
				}else if(estado==2 && distancia_n < 6){
					estado=1;
				}else if(estado==5 && distancia_n < 6){
					estado=1;
				}else if(estado==5 && distancia_n > 6){
					estado=2;
				}else if(estado==6){
					estado=1;
					mina=0;
				}

				if(estado==1 && distancia > 6){
						estado=2;
				}

			}else if(tipo==MINE){
				mina=1;
				if(estado==0){
					estado=6;
				}else if(estado==1){
					estado=6;
				}else if(estado==2){
					estado=6;
				}else if(estado==4){
					estado=6;
				}else if(estado==5){
					estado=6;
				}

				if(estado==1 && distancia > 4){
					estado=2;
				}

			}else if(tipo==COOKIE){
				tarta=1;
				if(estado==1){
					estado=5;
				}else if(estado==2){
					estado=5;
				}else if(estado==6){
					estado=5;
					mina=0;
				}else if(estado==7){
					estado=5;
				}

			}else if(tipo==NOOBJECT){

			}else if(tipo==SHOT){

			}
		}
	   }
	    break;

         case DEAD:
            printf("Print Jode con la babarruna...\n");
            fflush(stdout);
            break;
      }
   }
   signal(sig,Chequea_Mensaje);

}

Mensaje_A_Robot Devuelve_Mensaje(char* mensaje)
{
   int i,valor;
   valor=UNKNOWN_MESSAGE_TO_ROBOT;
   for(i=0; message_to_robot[i].msg[0] != '\0'; i++)
   {
      if(strcmp(message_to_robot[i].msg, mensaje) == 0)
         valor=(Mensaje_A_Robot)i;
   }
   return valor;
}
